%SMART HUS GRUNNSCENARIO

%Dette caset er grunnscenarioet og regner ut spenningen i 
%tilknytningspunktet, basert definert data i Simuleringen for 
%motstand og reaktans i nettet og spenningen i nettstasjonen og 
%import av effekt fra overfringsnettet som er gitt av differansen 
%mellom forbruket og lokal produksjon. Reaktiveffekt er i 
%dette caset null. 

function [U_kunde] = ...
        Case_2(Unett, P_import, Qsol, R, X, a, b, U_kunde, str)

%I det flgende regnes det ut spenningsverdier for hver halvtime, 
%hvor t gr fra 0 til 1440, som er 1 dgn i minuttsverdier. Spenningen er
%utregnet basert p utveksling av aktiv og reaktiv effekt med nettet, hvor
%spenningen i nettet er definert til 230 volt. Formelen for a(1,t)
%returnerer i utgangspunktet to verdier ettersom det er rotuttrykk, 
%det er kun den ene verdiene som er atkuell og utregnes videre. 
%Reaktiv effekt er som nevnt null i grunnscenariet. 
for t = 1:str
 if t == 1   
%Regner ut verdien for spenningen klokken 00:00
    a(1,t) 		= ((Unett + sqrt(Unett^2 - 4*(R*P_import(1,t))+...
                  (X*Qsol(1,t)) + (((R*Qsol(1,t)-X...
                   *P_import(1,t))/Unett) ^ 2 ))))/2;
    b(1,t) 		= ( R * Qsol(1,t) - X * P_import(1,t) )/Unett;
    U_kunde(1,t)= sqrt ( a(1,t) ^ 2 + b(1,t) ^ 2 );
 else
%Regner ut verdiene for spenningen for resten av dgnet 
%med halvtimes verdier - derav ((t-1)*30)
    a(1,t) 		= ((Unett+sqrt(Unett^2-4*(R*P_import(1,t))+...
                  (X*Qsol(1,(t-1)*30))+(((R*Qsol(1,(t-1)*30)-X...
                  *P_import(1,t))/Unett)^2))))/2;
    b(1,t) 		= (R*Qsol(1,(t-1)*30)-X*P_import(1,t))/Unett;
    U_kunde(1,t)= sqrt ( a(1,t) ^ 2 + b(1,t) ^ 2 );
 end
end
%returner maksimal utregnet spenningsverdi over dagen. 
MaxVerdi = max(U_kunde); 
MaxVerdi

end