%MIKRONETT MED REGULERING AV SPENNING

%Dette caset omfatter simulering av en mikronettstruktur med en  
%nettstasjon som forsyner en n antall hus. Husene er antatt  vre like  
%med lik produksjon og forbruk. Det er en avstand a mellom husene. 
%Basert p innmatet effekt regnes det er ut spenningsbidrag fra hvert hus, 
%som tilsammen utgjr spenningskarakterstikken for radialen. Unett er 
%er U linje i formelene i masteroppgaven. nettstasjon er referansen, og
%endringen i spenning utover radialen blir relatert den. i en situasjon
%hvor alle husene mater inn, vil det si at spenningen ytterst p radialen
%alts er nettstasjonsspenning + endringen i prosent. 


function [TotSpennFall_U, TotSpennFall_M, TotSpennFall_L,...
         TotSpennFall_J, n] = Case_5(Unett, P_import, R, X) 
    
%maksimal innmatet effekt er gitt av minimal P_import fra case2, omregnes
%til innmatet effekt i kW med positivt fortegn. Det er denne innmatede
%effekten som anvendes for hvert av de n husene i mikronettet, det
%ettersom den hyeste innmatede effekten resulterer i hyest spenning

P_max = - min(P_import)/1000; 

%kan angi antall hus, avstand og spenningsrestriksjoner i prosent
n      = input ('Hvor mange identiske hus? '); %det er anvnedt 5 hus
a      = input ('Identisk avstand mellom hus [m]: '); %det er anvendt 200
grense = input ('Max spenningsfall [0-100]: '); % det er anvendt 7%
drift  = 0;    %drift = driftskurven som er tan(arccos(effektfaktor)) er i 
               %utgangspunktet satt til null. 
    
%en null-matrise per n hus som angir spenningskarakterstikken fra n hus
    SpennFall = zeros(1,n); 
%en null-matrise for n hus angir effekten fra hvert hus (lik)
    LevertEffekt = zeros (1,n); 
    
%Hvert hus i radialen fr tildelt en lik effekt, som er gitt av
%maksimal innmatet effekt
    for i = 1:n
        LevertEffekt(1,i) = P_max * i; 
    end
    
%forhndsdefinert null-matriser for spenningkarakterstikken i radialen, 
    TotSpennFall_U = zeros(1,n); %Ordinrt
    TotSpennFall_M = zeros(1,n); %Med reaktiv kompensering
    TotSpennFall_L = zeros(1,n); %Med Lagring (aktiv regulering)
    TotSpennFall_J = zeros(1,n); %Med trinnstyring av transformator
    
%regner ut spenningen hos hver kunde i n hus,
for i = 1:n
  SpennFall(1,i) = ((LevertEffekt(1,i)*a)/Unett^2)*(R+X*drift)*100;
end
    
%summerer spenningendringen i radialen
    sum = 0;
    teller = 1;
    for i = 0:(n-1)
        sum = sum + SpennFall(1,(n-i));
        TotSpennFall_U(1,teller) = sum;
        teller = teller + 1;
    end
    
%hvis spenningskningen i radialen er strre enn 1%,
%s aktiveres reaktiv effekt forbruk og ny spenning regnes ut 
if sum > 1
  drift = -0.32868;
  for i = 1:n
   SpennFall(1,i) =((LevertEffekt(1,i)*a)/ Unett ^ 2)*(R + X * drift)*100;
  end
        
%hvis spenningsfallet i radialen er strre enn 1%,
%s aktiveres reaktiv effekt produksjon og ny spenning regnes ut     
  elseif sum < -1
   drift = 0.32868;
   for i = 1:n
    SpennFall(1,i) =((LevertEffekt(1,i)*a)/Unett ^ 2)*(R + X * drift)*100;
   end
end
    
%summerer spenningsendringen i radialen med reaktiv kompensering
  sum = 0;
  teller = 1;
  for i = 0:(n-1)
        sum = sum + SpennFall(1,(n-i));
        TotSpennFall_M(1,teller) = sum;
        teller = teller + 1;
  end
    
%Legger til nettstasjonen som referanse i punkt 0
TotSpennFall_U = [0, TotSpennFall_U]; %Uten kompensering, starter p 0
TotSpennFall_M = [0, TotSpennFall_M]; %Med kompensering, starter p 0
    
%Hvis spenningsfallet med kompensering er strre enn grensen definert
%s regnes det ut maks innmatet effekt for  overholde restriksjonen
%for spenning som er definert (grense) innebygd matlab-funksjon.
if TotSpennFall_M(1,(n+1)) > grense
%Likning som finner verdi for P slik at grensen blir overholdt,
%basert p summen av spenningsfallet i radialen
 problem.objective =@(P)((1/2)*n*(n+1))*((P*a)/Unett^2)*(R+X*drift)*100 ...
                    - grense;
 problem.x0        =0;
 problem.solver    ='fzero'; % a required part of the structure
 problem.options   =optimset(@fzero); % default options
 P                 =fzero(problem);
 %regner ut hvor mye som m lades eller forbrukes i huset
 Ladning           = P_max - P; 
aa =['Eksport:', num2str(P),'kW Forbruk/lagring:', num2str(Ladning),'kW'];     
        
%regner ut ny leverteffekt fra husene, og oppdaterers vektoren
  for i = 1:n
     LevertEffekt(1,i) = P * i; 
  end
        
%regner ut ny spenningsendring basert p ny levert effekt,
  for i = 1:n
   SpennFall(1,i) =((LevertEffekt(1,i)*a)/Unett^2)*(R + X*drift)*100;
  end
        
%summerer opp spenningsendringen over radialen
   sum = 0;
   teller = 1;
   for i = 0:(n-1)
      sum = sum + SpennFall(1,(n-i));
      TotSpennFall_L(1,teller) = sum;
      teller = teller + 1;
   end
        
%regner ut nytt startpunkt for trinnstyringen i nettstasjonen, slik
%at spenningsrestriksjonen for spenningsendring i radialen overholdes
        differ = TotSpennFall_M(1,(n+1)) - grense;
        TotSpennFall_J = TotSpennFall_M - differ;
end
    
%Legger til referansen i nettstasjon som plass 0 i spenninsendringen
%for caset med ladning eller kt forbruk
TotSpennFall_L = [0, TotSpennFall_L];
    
%Skriver ut spenningskarakterstikken
TotSpennFall_U %Ordinr
TotSpennFall_M %Med kompensering med reaktiv effekt
TotSpennFall_J %Trinnstyring
TotSpennFall_L %Med kt forbruk/lagring - regulering av aktiv effekt

disp(aa)    %skriver ut ny eksportert effekt fra hvert hus, 
            %og endring i ladning/forbruk

    
%Regner ut effektflyt mellom nettstasjon og det frste huset
P_U = P_max * n; %ordinr drift
P_M = P_max * n; %med kompensering
P_L = LevertEffekt(1,n); %lading
    
%Regner ut maksimal strm
Imax_U = P_U / ( sqrt(3) * Unett ); %ordinr
Imax_M = P_M / ( sqrt(3) * Unett * 0.95 ); %reaktiv
Imax_L = P_L / ( sqrt(3) * Unett * 0.95 ); %lagring
%trinnstyring
Imax_J = P_M / ( sqrt(3)*Unett*(1 - (differ / 100))*0.95);
	
%Skriver ut den maksimale strmmen for de ulike tiltakene 
xx = ['Strm: ', num2str(Imax_U) , ' A' ];
bb = ['Strm med reaktiv: ', num2str(Imax_M), ' A ' ];
cc = ['Strm med reaktiv og forbruk/lagring: ', num2str(Imax_L), ' A '];
dd = ['Strm med reaktiv og trinnstyring: ', num2str(Imax_J), ' A '];
%skriver ut tekststrengen
disp(xx)
disp(bb)
disp(cc)
disp(dd)
    
    
end